<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Event Propagation</title>
    <style>
        body {
            font-size: 12pt;
            font-family: sans-serif;
        }

        .first {
            margin-bottom: 3rem;
            text-align: center;
            background-color: #ddd;
            height: 11rem;
        }

        .second {
            background-color: green;
            width: 50rem;
            height: 8rem;
            position: relative;
            left: 2rem;
            top: 2rem;
        }

        .third {
            background-color: orangered;
            color: white;
            padding: 1rem;
            width: 40rem;
            height: 3rem;
            position: relative;
            left: 2rem;
            top: 2rem;
        }

        .third:hover {
            border: thin solid yellow;
        }
        pre {
            margin-top: -25px;
        }
    </style>
</head>
<body>
    <h1>Event Propagation</h1>
    <div id="bubble">
        <div class="first">
            <div class="second">
                <div class="third">
                    Click Me, I'm bubbling !!!<br/>
                    Executing event-handlers on the way up to the root
                </div></div></div>
        <pre></pre>
    </div>
    <div id="capture">
        <div class="first">
            <div class="second">
                <div class="third">
                    Click Me, I'm capturing !!!<br/>
                    Executing event-handlers on the way down to the target
                </div></div></div>
        <pre></pre>
    </div>
    <script>
        function handler(propagation) {
            ['first', 'second', 'third'].forEach(css => {
                let selector = `#${propagation} .${css}`;
                let node = document.querySelector(selector);
                console.log('selector', selector, node);
                if (node) node.addEventListener('click', (ev) => {
                    document.querySelector(`#${propagation} pre`)
                        .innerText += `DIV.${css} (${ev.timeStamp})\n`;
                }, (propagation === 'capture'))
            });
        }
        handler('bubble');
        handler('capture');
    </script>
</body>
</html>

